=== debian/changelog ===
xtensor (0.27.1-2) unstable; urgency=medium

  * debian/tests on i386: add -DMARK_FLAKEY_TEST to CXXFLAGS not cmake option
    CMAKE_CXX_FLAGS to avoid wiping other options set in CXXFLAGS
    (-DXTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS in particular)

 -- Drew Parsons <dparsons@debian.org>  Tue, 10 Feb 2026 22:52:57 +0100

xtensor (0.27.1-1) unstable; urgency=medium

  * New upstream release
    - update versioned Build-Depends: xtl-dev (>= 0.8.0~),
      cmake (>= 3.15)
    - applies or deprecates debian patches clang19_feature_check.patch
      and test_xinfo_no_clang.patch
    - provides xeus-cpp config files
  * drop xsimd support until compatible xsimd version is available
    (see Bug#1061243)
  * debian patch install_sysconfdir.patch installs etc/xeus-cpp config
    files in CMAKE_INSTALL_SYSCONFDIR to get /etc installed separately
    from /usr when CMAKE_INSTALL_PREFIX=/usr (set by debhelper cmake)
  * debian/libxtensor-dev.install prepend debian/tmp in front of the
    etc/xeus-cpp config file to work around Bug#1127452 in dh_missing
  * debian patch docs_intersphinx.patch uses local objects.inv to
    reference numpy and scipy docs.
    Build-Depends-Indep: python-numpy-doc, python-scipy-doc <!nodoc>
  * Build-Depends-Indep: texlive <!nodoc> (for latex)
  * debian/tests: set -DXTENSOR_FORCE_TEMPORARY_MEMORY_IN_ASSIGNMENTS
    explicitly to avoid binding reference errors. See upstream #2887.
  * update debian/watch to v5 GitHub template
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Feb 2026 18:38:05 +0100
